// Copyright David Abrahams 2002. Permission to copy, use,
// modify, sell and distribute this software is granted provided this
// copyright notice appears in all copies. This software is provided
// "as is" without express or implied warranty, and with no claim as
// to its suitability for any purpose.
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>

void* get_entry(char const* libname, char const* entry_name)
{
    char const* err;
    void* lib = dlopen(libname, RTLD_LOCAL | RTLD_NOW);
    if (lib == 0)
    {
        printf("%s\n",dlerror());
        exit(1);
    }

    void* entry = dlsym(lib, entry_name);
    err = dlerror();
    if (err)
    {
        printf("%s\n",err);
        exit(2);
    }
    return entry;
}

int main()
{
    printf("testing entry1\n");
    void (*entry1)() = get_entry("libext1.so", "entry");
    entry1();
    
    printf("testing entry2\n");
    void (*entry2)() = get_entry("libext2.so", "entry");
    entry2();
    
    return 0;
}
